/* vim:set ts=2 sw=2 sts=2 expandtab */
/*jshint asi: true undef: true es5: true node: true devel: true
         forin: false latedef: false */
/*global define: true */

!(typeof define !== "function" ? function($){ $(require, exports, module); } : define)(function(require, exports, module, undefined) {

'use strict';

function _(target) {
  if (target.valueOf.length === 0)
    _.initialize(target)
  return target.valueOf(_)
}
_.initialize = function initialize(target) {
  var _valueOf = target.valueOf;
  var privates = {};
  target.valueOf = function valueOf(privates) {
    return privates === _ ? privates : _valueOf.call(target, privates)
  }
}

var True = Boolean.bind(null, true)

function stack(stream) {
  return _(stream).stack
}
exports.stack = stack

function history(stream) {
  return _(stream).history
}
exports.history = history

function breakpoints(stream) {
  return _(stream).breakpoints
}
exports.breakpoints = breakpoints

exports.reason = function reason(stream) {
  return _(stream).reason
}

exports.isStopped = function reason(stream) {
  return _(stream).isStopped
}

exports.suspend = function suspend(stream, condition) {
  breakpoints(stream).push(condition || True)
}

exports.resume = function resume(stream) {
  var index, breaks = breakpoints(stream)
  while ((index = breaks.indexOf(True)) >= 0)
    breaks.slice(index, 1)
  exports.next(stream)
}

exports.next = function next(stream, element) {
  element = element || stack(stream).shift()
  history(stream).push(element)
  _(stream).next(element)
}

exports.stop = function stop(stream, reason) {
  reason = arguments.length === 2 ? reason : exports.reason(stream)
  _(stream).stop(reason)
}

exports.debug = function debug(source) {
  var stream = function debugStream(next, stop) {
    _(stream).next = next
    _(stream).stop = stop
    source(function onNext(element) {
      stack(stream).push(element)
      // If stream has no matching breakpoint we just continue.
      var suspend = breakpoints(stream).some(function(condition) {
        return condition('next', element, stack(stream), history(stream))
      })
      if (!suspend)
        exports.next(stream)
    }, function onStop(error) {
      _(stream).reason = error
      _(stream).isStopped = true
      var suspend = breakpoints(stream).some(function(condition) {
        return condition('stop', error, stack(stream), history(stream))
      })
      if (!suspend)
        exports.stop(stream)
    })
  }
  _(stream).breakpoints = []
  _(stream).stack = []
  _(stream).history = []
  _(stream).isStopped = false
  return stream
}

});
